# (tv) to be really fixed:
%define _disable_ld_no_undefined 1

%define php_inidir    %{_sysconfdir}/php.d
%define with_ruby     0

Name:           redland-bindings
Version:        1.0.17.1
Release:        %mkrel 18
Summary:        Redland RDF Application Framework API Bindings

Group:          System/Libraries
License:        LGPLv2+ or GPLv2+ or ASL 2.0
URL:            https://librdf.org/
Source:         https://download.librdf.org/source/%{name}-%{version}.tar.gz
%define         redland_ver 1.0.15
%define         redland_version %(pkg-config --modversion redland 2>/dev/null || echo %{redland_ver})

BuildRequires:  pkgconfig(redland) >= %{redland_ver}
BuildRequires:  perl(ExtUtils::MakeMaker)
BuildRequires:  perl-devel
BuildRequires:  ruby
%if %with_ruby
BuildRequires:  pkgconfig(ruby)
%endif
# (tv) for /usr/share/redland/Redland.i:
BuildRequires:  redland
%if %with_ruby
# ruby testsuite
BuildRequires:  rubygem(test-unit)
%endif
BuildRequires:  swig

%description
Redland is a library that provides a high-level interface for RDF
(Resource Description Framework) implemented in an object-based API.
It is modular and supports different RDF/XML parsers, storage
mechanisms and other elements. Redland is designed for applications
developers to provide RDF support in their applications as well as
for RDF developers to experiment with the technology.

%package        common
Summary:        Redland RDF Application Framework API Bindings
Group:          System/Libraries

%description common
Redland is a library that provides a high-level interface for RDF
(Resource Description Framework) implemented in an object-based API.
It is modular and supports different RDF/XML parsers, storage
mechanisms and other elements. Redland is designed for applications
developers to provide RDF support in their applications as well as
for RDF developers to experiment with the technology.


%{!?perl_vendorarch: %define perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)}
%define perlver %(eval "`%{__perl} -V:version`"; echo $version)

%package -n     perl-redland
Summary:        Perl modules for the Redland RDF library
Group:          Development/PHP
Requires:       redland >= %{redland_version}
Requires:       redland-bindings-common

%description -n perl-redland
The perl-redland package contains the parts of Redland that provide
an interface to Perl.

%global php_apiver  %((echo 0; php -i 2>/dev/null | sed -n 's/^PHP API => //p') | tail -1)
%if %{php_apiver}
# So that BS can rebuild the SRPM with --nodeps:
%{!?php_extdir: %{expand: %%global php_extdir %_libdir/php/extensions}}
%if "%{php_version}" < "5.6"
%global ini_name     redland.ini
%else
%global ini_name     40-redland.ini
%endif
%else
# Use dummy values when building source package to prevent from RPM warnings
%global php_zend_api 0
%global php_core_api 0
%endif

%if %with_ruby
%package -n     ruby-redland
Summary:        Ruby modules for the Redland RDF library
Group:          Development/PHP
Requires:       redland >= %{redland_version}
Requires:       redland-bindings-common
Requires:       ruby(release)

%description -n ruby-redland
The ruby-redland package contains the parts of Redland that provide
an interface to Ruby.
%endif

%prep
%autosetup

# Force swig to regenerate the wrapper
rm -f php/redland_wrap.c php/php_redland.h
rm -f perl/CORE_wrap.c

cat <<'EOF' >php/%{ini_name}
; Enable the 'Redland' extension module
extension=redland.so
EOF


%build
autoreconf
%configure \
  --without-python \
  --with-perl \
%if %with_ruby
  --with-ruby --with-ruby-arch-install-dir-variable=vendorarchdir \
  --with-ruby-install-dir=%{ruby_vendorarchdir} \
%endif
  --with-php=no
cd perl
make MAKE_PL_OPTS="PREFIX=/usr INSTALLDIRS=vendor" %{?_smp_mflags}
cd ..
rm -rf php

%make_build

%install
cd perl
make install PERL_INSTALL_ROOT=$RPM_BUILD_ROOT PREFIX=/usr INSTALLDIRS=vendor
find $RPM_BUILD_ROOT -type f -name .packlist -exec rm -f {} ';'
find $RPM_BUILD_ROOT -type f -name '*.bs' -size 0 -exec rm -f {} \;
find $RPM_BUILD_ROOT -type d -depth -exec rmdir {} 2>/dev/null ';'
# by default CORE.so gets 0555, fix it
find $RPM_BUILD_ROOT -type f -name '*.so' -exec chmod 755 {} \;
# if we want this as documentation, it cannot be executable
chmod -x example.pl
cd ..

%if %with_ruby
cd ruby
# the ruby bindings need DESTDIR
make DESTDIR=$RPM_BUILD_ROOT install
# .so's need to be executable for rpm to strip them
#chmod +x $RPM_BUILD_ROOT%{ruby_vendorarchdir}/redland.so
cd ..
%endif

%check
# make check hints at some ruby fail, not sure if that's a real problem
# or something specific to the tests themselves -- rex
make check ||:
#%%{_bindir}/php \
#    -n -d extension_dir=${RPM_BUILD_ROOT}%{php_extdir} \
#    -d extension=redland.so \
#    -m | grep redland

%files common
%doc AUTHORS COPYING COPYING.LIB ChangeLog
%doc LICENSE.txt NEWS README TODO
%doc LICENSE.html NEWS.html README.html TODO.html
%doc LICENSE-2.0.txt NOTICE
%doc RELEASE.html

%files -n perl-redland
%doc docs/perl.html
%attr(664,root,root) %doc perl/example.pl
%{perl_vendorarch}/auto/
%{perl_vendorarch}/RDF/
%{_mandir}/man3/RDF::Redland*.3pm*

%if %with_ruby
%files -n ruby-redland
%doc docs/ruby.html
%doc ruby/example.rb

#%{ruby_vendorarchdir}/redland.so
%{ruby_vendorarchdir}/rdf
%endif


%changelog
* Fri Aug 23 2024 tv <tv> 1.0.17.1-18.mga10
+ Revision: 2089696
- Rebuild for perl-5.40

* Tue Dec 05 2023 daviddavid <daviddavid> 1.0.17.1-17.mga10
+ Revision: 2013223
- rebuild for new perl 5.38.0

* Tue Jun 07 2022 umeabot <umeabot> 1.0.17.1-16.mga9
+ Revision: 1862776
- Rebuild for Perl 5.36

* Sun Apr 03 2022 umeabot <umeabot> 1.0.17.1-15.mga9
+ Revision: 1841492
- Mageia 9 Mass Rebuild

* Mon May 24 2021 umeabot <umeabot> 1.0.17.1-14.mga9
+ Revision: 1727372
- Rebuild for perl 5.34

* Thu Jan 28 2021 neoclust <neoclust> 1.0.17.1-13.mga8
+ Revision: 1673805
- Disable ruby subpackage
+ mokraemer <mokraemer>
- remove php support

* Wed Jun 17 2020 umeabot <umeabot> 1.0.17.1-11.mga8
+ Revision: 1595319
- Rebuild for perl 5.32

* Fri Apr 17 2020 tv <tv> 1.0.17.1-10.mga8
+ Revision: 1568317
- fix macro expansion to work w/o BRs on BS when recreating SRPM
+ pterjan <pterjan>
- Rebuild for ruby 2.7
+ daviddavid <daviddavid>
- Mageia 8 Mass Rebuild
- drop python2 only support
+ wally <wally>
- replace deprecated %%configure2_5x

* Tue Aug 27 2019 tmb <tmb> 1.0.17.1-8.mga8
+ Revision: 1433887
- rebuild for perl 5.30

* Mon Oct 08 2018 tv <tv> 1.0.17.1-7.mga7
+ Revision: 1318613
- fix php7 support
- Rename python subpackage to python2-redland
- Fix building source package (rhbz#1482157)
- rebuild for perl-5.28
+ umeabot <umeabot>
- Mageia 7 Mass Rebuild

* Tue Aug 15 2017 pterjan <pterjan> 1.0.17.1-5.mga7
+ Revision: 1140815
- Rebuild for new Ruby

* Sat Jul 22 2017 neoclust <neoclust> 1.0.17.1-4.mga7
+ Revision: 1126826
- Rebuild against new Perl 5.26

* Sun Jun 19 2016 pterjan <pterjan> 1.0.17.1-3.mga6
+ Revision: 1036361
- Rebuild for perl 5.22.2

* Fri Feb 12 2016 umeabot <umeabot> 1.0.17.1-2.mga6
+ Revision: 958917
- Mageia 6 Mass Rebuild
+ pterjan <pterjan>
- Update to 1.0.17.1 (not enough to build with new php :( )

* Sat Jun 27 2015 tv <tv> 1.0.16.1-4.mga6
+ Revision: 846063
- rebuild for soname-ifed perl

* Wed Jun 24 2015 sander85 <sander85> 1.0.16.1-3.mga6
+ Revision: 841755
- Rebuild for perl 5.22

* Fri Jan 23 2015 tv <tv> 1.0.16.1-2.mga5
+ Revision: 812024
- remove bogus perl deps

* Sat Jan 03 2015 tv <tv> 1.0.16.1-1.mga5
+ Revision: 808258
- BR php-cli
- BR perl-devel
- imported package redland-bindings

